#Region "Imports"
Imports System.Collections.Generic
Imports System.Data
Imports System.Data.Odbc
Imports System.Data.SqlClient
Imports Telerik.Web.Ui
Imports UtilitySql
#End Region

#Region "Custom Imports"
%%Insert Imports
%%EndInsert
#End Region

Public Class %ClassSourceName%
    Implements IEnumerable

#Region "Custom Constants"
%%Insert Constants
%%EndInsert
#End Region

#Region "Data"
    Private m_bSortAsc As Boolean = True
    Private m_s%SortParam% As String = ""
    Private m_oBeanList As New List(Of %ClassBeanName%)
#End Region

#Region "Custom Data"
%%Insert Data
%%EndInsert
#End Region

#Region "Constructors"
    Public Sub New(oBeanList As List(Of %ClassBeanName%))
        m_oBeanList = oBeanList
    End Sub
#End Region

#Region "Custom Constructors"
%%Insert Constructors
%%EndInsert
#End Region

#Region "Custom Properties"
%%Insert Properties
%%EndInsert
#End Region

#Region "Public Routines"
    Public Function %MethodDelete%(ByVal oBean As %ClassBeanName%) As Integer
        Return DeleteData(oBean)
    End Function

    Public Function GetEnumerator() As IEnumerator Implements IEnumerable.GetEnumerator
        Return m_oBeanList.GetEnumerator
    End Function

    Public Function %MethodGetCount%() As Integer
        If m_oBeanList Is Nothing Then
            Return 0
        Else
            Return m_oBeanList.Count
        End If
    End Function

    Public Function %MethodGet%() As List(Of %ClassBeanName%)
        Return GetRecords("", 0, 1)
    End Function

    Public Function %MethodGet%(ByVal maximumRows As Integer, ByVal startRowIndex As Integer) As List(Of %ClassBeanName%)
        Return GetRecords("", maximumRows, startRowIndex)
    End Function

    Public Function %MethodGet%(ByVal %SortParam% As String) As List(Of %ClassBeanName%)
        Return GetRecords(%SortParam%, 0, 1)
    End Function

    Public Function %MethodGet%(ByVal %SortParam% As String, ByVal maximumRows As Integer, ByVal startRowIndex As Integer) As List(Of %ClassBeanName%)
        Dim iMaximumRows As Integer = maximumRows
        Dim iStartRowIndex As Integer = startRowIndex

        If Not String.IsNullOrEmpty(%SortParam%) Then
            Dim sSortParam As String = %SortParam%
            If sSortParam.ToLower().EndsWith(" asc") Then
                m_bSortAsc = True
                sSortParam = sSortParam.SubString(0, sSortParam.Length - 4)
            ElseIF sSortParam.ToLower().EndsWith(" desc") Then
                m_bSortAsc = False
                sSortParam = sSortParam.SubString(0, sSortParam.Length - 5)
            Else
                m_bSortAsc = CBool(IIf(%SortParam% = m_s%SortParam%, Not m_bSortAsc, True))
            End If

            Select Case sSortParam
                %%Repeat Field
                %%If SortField
                Case Is = "%FieldName%"
                    m_oBeanList.Sort(AddressOf SortBy%FieldName%)
                %%EndIf
                %%EndRepeat
            End Select
            m_s%SortParam% = %SortParam%
        End If

        If iStartRowIndex = 0 Then
            iStartRowIndex = 1
        End If
        If iMaximumRows <= 0 OrElse iMaximumRows > m_oBeanList.Count OrElse iStartRowIndex < 1 OrElse iStartRowIndex >= m_oBeanList.Count Then
            Return m_oBeanList
        Else
            If iStartRowIndex + iMaximumRows > m_oBeanList.Count Then
                iMaximumRows = m_oBeanList.Count - iStartRowIndex
            End If
            Return m_oBeanList.GetRange(iStartRowIndex - 1, iMaximumRows)
        End If
    End Function

    Public Function %MethodInsert%(ByVal oBean As %ClassBeanName%) As Integer
        Return InsertData(oBean)
    End Function

    Public Function %MethodUpdate%(ByVal oBean As %ClassBeanName%) As Integer
        Return UpdateData(oBean)
    End Function
#End Region

#Region "Private Routines"
    Private Sub GetData(ByVal sSqlStatement As String)
        %%If DataReader
        Dim oCommand As SqlCommand = Nothing
        Dim oConnection As SqlConnection = Nothing
        Dim oDataReader As SqlDataReader = Nothing

        %%EndIf
        Try
            %%If DataReader
            oConnection = SqlBase.OpenConnection(WebConfig.ConnectionString)
            oDataReader = SqlBase.QueryDataReader(oCommand, oConnection, sSqlStatement, WebConfig.CommandTimeout)
            While oDataReader.Read()
                LoadData(oDataReader)
            End While
            %%EndIf
            %%If DataSet
            Dim oDataSet As DataSet
            oDataSet = SqlBase.QueryDataSet(WebConfig.ConnectionString, sSqlStatement, WebConfig.CommandTimeout)
            For Each oDataRow As DataRow In oDataSet.Tables(0).Rows
                LoadData(oDataRow)
            Next
            SqlBase.CloseDataSet(oDataSet)
            %%EndIf
            %%If DataTable
            Dim oDataTable As DataTable
            oDataTable = SqlBase.QueryDataTable(WebConfig.ConnectionString, sSqlStatement, WebConfig.CommandTimeout)
            For Each oDataRow As DataRow In oDataSet.Tables(0).Rows
                LoadData(oDataRow)
            Next
            SqlBase.CloseDataTable(oDataTable)
            SqlBase.CloseDataSet(oDataSet)
            %%EndIf
        Catch oEx As Exception
            Dim oError As New SiteError(oEx)
        %%If DataReader
        Finally
            SqlBase.CloseCommand(oCommand)
            SqlBase.CloseDataReader(oDataReader)
            SqlBase.CloseConnection(oConnection)
        %%EndIf
        End Try
    End Sub

    Private Sub GetData(ByVal sStoredProcedure As String, ByVal oParamList As List(Of SqlParameter))
        %%If DataReader
        Dim oCommand As SqlCommand = Nothing
        Dim oConnection As SqlConnection = Nothing
        Dim oDataReader As SqlDataReader = Nothing

        %%EndIf
        Try
            %%If DataReader
            oConnection = SqlBase.OpenConnection(WebConfig.ConnectionString)
            oDataReader = SqlBase.QueryDataReader(oCommand, oConnection, sStoredProcedure, oParamList, WebConfig.CommandTimeout)
            While oDataReader.Read()
                LoadData(oDataReader)
            End While
            %%EndIf
            %%If DataSet
            Dim oDataSet As DataSet
            oDataSet = SqlBase.QueryDataSet(WebConfig.ConnectionString, sStoredProcedure, oParamList, WebConfig.CommandTimeout)
            For Each oDataRow As DataRow In oDataSet.Tables(0).Rows
                LoadData(oDataRow)
            Next
            SqlBase.CloseDataSet(oDataSet)
            %%EndIf
            %%If DataTable
            Dim oDataTable As DataTable
            oDataTable = SqlBase.QueryDataTable(WebConfig.ConnectionString, sStoredProcedure, oParamList, WebConfig.CommandTimeout)
            For Each oDataRow As DataRow In oDataSet.Tables(0).Rows
                LoadData(oDataRow)
            Next
            SqlBase.CloseDataTable(oDataTable)
            SqlBase.CloseDataSet(oDataSet)
            %%EndIf
        Catch oEx As Exception
            Dim oError As New SiteError(oEx)
        %%If DataReader
        Finally
            SqlBase.CloseCommand(oCommand)
            SqlBase.CloseDataReader(oDataReader)
            SqlBase.CloseConnection(oConnection)
        %%EndIf
        End Try
    End Sub
    %%Repeat Field
    %%If SortField

    Private Function SortBy%FieldName%(ByVal o1 As %ClassBeanName%, ByVal o2 As %ClassBeanName%) As Integer
        If m_bSortAsc Then
            Return o1.%FieldName%.CompareTo(o2.%FieldName%)
        Else
            Return o2.%FieldName%.CompareTo(o1.%FieldName%)
        End If
    End Function
    %%EndIf
    %%EndRepeat
#End Region

#Region "Custom Routines"
%%Insert Routines
    Private Function DeleteData(ByVal oBean As %ClassBeanName%) As Integer
        ' Add logic here to implement delete processing
        Return 0
    End Function

    Private Function InsertData(ByVal oBean As %ClassBeanName%) As Integer
        ' Add logic here to implement insert processing
        Return 0
    End Function

    %%If DataReader
    Private Sub LoadData(ByVal oData As SqlDataReader)
    %%EndIf
    %%If DataSet
    Private Sub LoadData(ByVal oData As DataRow)
    %%EndIf
    %%If DataTable
    Private Sub LoadData(ByVal oData As DataRow)
    %%EndIf
        Try
            Dim oBean As New %ClassBeanName%

            With oBean
                ' Add logic here for loading the bean object
            End With

            m_oBeanList.Add(oBean)
        Catch oEx As Exception
            Dim oError As New SiteError(oEx)
        End Try
    End Sub

    Private Function UpdateData(ByVal oBean As %ClassBeanName%) As Integer
        ' Add logic here to implement update processing
        Return 0
    End Function
%%EndInsert
#End Region

End Class

Public Class %ClassBeanName%

#Region "Constants"
    %%Repeat Command
    Public Const Command%CommandName% As String = "%CommandName%"
    %%EndRepeat

    %%Repeat Field
    Public Const Field%FieldName% As String = "%FieldName%"
    %%EndRepeat
#End Region

#Region "Data"
    %%Repeat Field
    Private m_%FieldNameApp% As %FieldDataType% = %FieldDefaultValue%
    %%EndRepeat
#End Region

#Region "Properties"
    %%Repeat Field
    Public Property %FieldName%() As %FieldDataType%
        Get
            Return m_%FieldNameApp%
        End Get
        Set(ByVal value As %FieldDataType%)
            m_%FieldNameApp% = value
        End Set
    End Property

    %%EndRepeat
#End Region

End Class
